C     PROGRAM RVLIB4
C
C-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
C
C          AUTHORS   C. ED FORD, AND ROBERT A. MCLAREN
C                    UNION CARBIDE NUCLEAR DIVISION
C                    P.O. BOX P , MS 38
C                    OAK RIDGE, TN 37830
C                    PH 615-574-8685 OR
C                       FTS 624-8685 .
C
C          REVISED DECEMBER 7, 1981
C
C          INSTALLED ON DG 6000 BY C.W.ADKISSON, OCTOBER 1986
C
C          A COLLECTION OF SUBPROGRAMS FOR THE MANIPULATION OF
C          RANDOM VARIABLES (NORMALLY AND LOGNORMALLY DISTRIBUTED) #
C          AND THE CALCULATION OF MOMENTS OF SUMS AND PRODUCTS
C          OF RANDOM VARIABLES .
C          ALSO, A COLLECTION OF SUBPROGRAMS FOR THE DETERMINATION
C          OF PEARSON TYPE AND THE MANIPULATION OF PIECEWISE LINEAR
C          APPROXIMATIONS TO PEARSON DISTRIBUTION FUNCTIONS .
C
C-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
C
      SUBROUTINE SUMIND ( A,B,C )
      REAL*8 A(4),B(4),C(4)
      CALL SUM4MI(A(1),A(2),A(3),A(4),B(1),B(2),B(3),B(4),
     .            C(1),C(2),C(3),C(4))
      RETURN
      ENTRY SUMCOR ( A,B,C )
      CALL PCSUM (A(1),A(2),A(3),A(4),B(1),B(2),B(3),B(4),
     .            C(1),C(2),C(3),C(4))
      RETURN
      END
      SUBROUTINE GMOM4 ( XL,XM,XU,PL,PU,SCLFCT,XMOM,IERR )
C
C          FITS LOGNORMAL DISTRIBUTION TO SINGLE PRECISION
C          XL,XM,XU,PL,PU #  RETURNS REAL*8 SCALE
C          FACTOR (SCLFCT) AND MOMENTS (XMOM).
C
      REAL*8 SCLFCT,XMOM(4)
      REAL*8 QNTN01,CL,CU,X8(3),MU,S,D
C
      ENTRY GMOM4B ( XL,XM,XU,PL,PU,SCLFCT,XMOM,MU,S,D,IERR )
C
      CL=QNTN01(PL*1D0)
      CU=QNTN01(PU*1D0)
      SCLFCT=AMAX1(ABS(XL),ABS(XM),ABS(XU))
      X8(1)=XL/SCLFCT
      X8(2)=XM/SCLFCT
      X8(3)=XU/SCLFCT
      CALL GETMOM(X8,CL,CU,MU,S,D,IERR,XMOM)
      RETURN
      END
      SUBROUTINE GETMOM ( X,C1,C2,MU,S,D,IFLAG,MOM )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 X(3),MOM(4),MU
      CALL L4MODE(X(1),X(2),X(3),C1,C2,MU,S,D,IFLAG)
      IF(IABS(IFLAG).GT.1) GO TO 10
      XL=0
      IF(IFLAG.GT.0 .AND. D.GT.0) XL=D
      XU=DMAX1(QNTLN4(MU,S,D,IFLAG,0.995D0),X(3))
      CALL TRNCL4(MU,S,D,IFLAG,XL,XU,MOM(1),MOM(2),MOM(3),MOM(4),PR)
      IF(DMIN1(MOM(1),MOM(2),MOM(4)).GT.0) RETURN
10    DO 20 I=1,4
20    MOM(I)=0
      RETURN
      END
      FUNCTION DENLN4 ( MU,S,D,IFLAG,X )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      PHI(Z)=DEXP(-0.5D0*Z**2)/2.506628275D0
      IF(IFLAG.NE.0) GO TO 20
      DENLN4=PHI((X-MU)/S)/S
      RETURN
20    EMU=IFLAG*DEXP(MU)
      DIFF=(X-D)/EMU
      DENLN4=0D0
      IF(DIFF.LE.0D0) RETURN
      DENLN4=PHI(DLOG(DIFF)/S)/(S*DABS(X-D))
      RETURN
      END
      SUBROUTINE GREVDF ( MOM,PR,XP,TYPEID,B1,B2,ICODE )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MOM(4),PR(25),XP(25),PF(25)
      CHARACTER*10 TYPEID
      DATA PF/.005D0,.01D0,.025D0,19*0D0,.975D0,.99D0,.995D0/
      NUM=4
      CALL GPMOM(MOM(1),MOM(2),MOM(3),MOM(4),PF(4),XP(4),NUM,
     .     TYPEID,B1,B2,ICODE,XMODE)
      CALL GPRSN2(PF(1),XP(1),3)
      CALL GPRSN2(PF(23),XP(23),3)
      DO 10 I=1,25
10    PR(I)=1-PF(I)
      RETURN
      END
      SUBROUTINE GPMOM ( EX,VAR,E3,E4,PR,XP,NUM,TYPEID,B1,B2,ICODE
     .,XMODE)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*10 TYPEID
      DIMENSION XP(NUM),PR(NUM),DENS(NUM),X(151),FQ(151),DQ(151)
      EXTERNAL PRSNQP
      NP=2
      N=151
      B1=0
      B2=0
      ICODE=0
      NOFIT=1
      IF(DMIN1(VAR,E4).LE.1D-16*EX**2) GO TO 85
      STDEV=DSQRT(VAR)
      XL=-EX/STDEV
      XU=XL
      CALL INPRSN(EX,VAR,E3,E4,XL,XU,B1,B2,
     .            AP,XK,C0,C1,C2,ITYPE,TYPEID)
      NOFIT=0
      IF(ITYPE.LE.0) NOFIT=1
      ICODE=NOFIT
      IF(NOFIT.NE.0) GO TO 85
      CALL GNODES(XL,-C1,XU,X,N,B1)
      M=(N+1)/2
      IF(-C1.LE.XL) M=1
      IF(-C1.GE.XU) M=N
      FQ(M)=0.5
      DQ(M)=0.4
      MP1=M+1
      IF(M.GE.N) GO TO 60
      DO 50 I=MP1,N
50    CALL GQPRSN(X(I-1),DQ(I-1),FQ(I-1),X(I),DQ(I),FQ(I),NP)
60    IF(M.LE.1) GO TO 70
      MM1=M-1
      DO 65 I=1,MM1
65    CALL GQPRSN(X(MP1-I),DQ(MP1-I),FQ(MP1-I),X(M-I),
     . DQ(M-I),FQ(M-I),NP)
70    A=FQ(1)
      B=1/(FQ(N)-FQ(1))
      DO 80 I=1,N
      FQ(I)=(FQ(I)-A)*B
      DQ(I)=DQ(I)*B/STDEV
80    CONTINUE
85    P=0.05
      K=0
      DO 90 I=1,19
      PR(I)=P
      XP(I)=0
      IF(NOFIT.NE.0) GO TO 90
      K=INTVL2(P,K,FQ,N)
      XP(I)=X(K)+(P-FQ(K))*(X(K+1)-X(K))/(FQ(K+1)-FQ(K))
      XP(I)=EX+XP(I)*STDEV
90    P=P+0.05
      XMODE = 0D0
      IF (NOFIT.EQ.0) XMODE=EX-C1*STDEV
      RETURN
C
      ENTRY GPRSN2 ( PR,XP,NPR )
C
      K=0
      DO 100 I=1,NPR
      XP(I)=0
      IF(NOFIT.NE.0) GO TO 100
      K=INTVL2(PR(I),K,FQ,N)
      XP(I)=X(1)
      IF(K.LT.1) GO TO 95
      XP(I)=X(N)
      IF(K.GE.N) GO TO 95
      XP(I)=X(K)+(PR(I)-FQ(K))*(X(K+1)-X(K))/(FQ(K+1)-FQ(K))
95    XP(I)=EX+XP(I)*STDEV
100   CONTINUE
      RETURN
C
      ENTRY GPRSN3 ( XP,PR,NPR )
C
      K=0
      DO 200 I=1,NPR
      PR(I)=0
      IF(NOFIT.NE.0) GO TO 200
      XX=(XP(I)-EX)/STDEV
      K=INTVL2(XX,K,X,N)
      PR(I)=0
      IF(K.LT.1) GO TO 200
      PR(I)=1D0
      IF(K.GE.N) GO TO 200
      PR(I)=FQ(K)+(XX-X(K))*(FQ(K+1)-FQ(K))/(X(K+1)-X(K))
200   CONTINUE
      RETURN
C
      ENTRY GPRSN4 ( XP,DENS,ND )
C
      K=0
      DO 300 I=1,ND
      DENS(I)=0
      IF(NOFIT.NE.0) GO TO 300
      XX=(XP(I)-EX)/STDEV
      K=INTVL2(XX,K,X,N)
      IF(K.LT.1 .OR. K.GE.N) GO TO 300
      DENS(I)=DQ(K)+(XX-X(K))*(DQ(K+1)-DQ(K))/(X(K+1)-X(K))
300   CONTINUE
      RETURN
      END
      SUBROUTINE GQPRSN ( A,DA,FA,B,DB,FB,NP )
C
C          SOLUTION OF PEARSON DIFFERENTIAL EQUATION BY TWO-FOLD
C          GAUSSIAN QUADRATURE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MP1,MP2,CQ(5,5),XQ(5,5)
      DATA NQMIN/1/,NQMAX/5/,
     .     CQ/2D0,4*0D0,
     .        2*1D0,3*0D0,
     .        .5555555555D0,.8888888890D0,.5555555555D0,2*0D0,
     .        .347855D0,.652145D0,.652145D0,.347855D0,0D0,
     .        .236927D0,.478629D0,.568889D0,.478629D0,.236927D0/,
     .     XQ/0D0,4*0D0,
     .        -.577350D0,.577350D0,3*0D0,
     .        -.774597D0,0D0,.774597D0,2*0D0,
     .        -.861136D0,-.339981D0,.339981D0,.861136D0,0D0,
     .        -.906180D0,-.538469D0,0D0,.538469D0,.906180D0/
      NQ=NP
      IF(NQ.LT.NQMIN) NQ=NQMIN
      IF(NQ.GT.NQMAX) NQ=NQMAX
      X1=A
      D1=DA
      FB=0
      DX1=(B-A)*0.5
      MP1=(B+A)*0.5
      I=1
10    X2=MP1+DX1*XQ(I,NQ)
20    DX2=(X2-X1)*0.5
      MP2=(X2+X1)*0.5
      DB=0
      DO 30 J=1,NQ
      XJ=MP2+DX2*XQ(J,NQ)
      CALL PRSNQP(XJ,Q,P)
      DB=DB+CQ(J,NQ)*Q/P
30    CONTINUE
      DB=D1*DEXP(-DX2*DB)
      IF(I.GT.NQ) RETURN
      X1=X2
      D1=DB
      FB=FB+CQ(I,NQ)*DB
      I=I+1
      IF(I.LE.NQ) GO TO 10
      FB=FA+DX1*FB
      X2=B
      GO TO 20
      END
      SUBROUTINE INPRSN ( EX,V,T,F,XL,XU,BETA1,BETA2,AP,XK,
     .                    C0,C1,C2,ITYPE,TYPEID )
C
C          FROM THE MEAN, VARIANCE, 3RD & 4TH MOMENTS (EX,V,T,F) , INPRSN
C          DETERMINES THE PEARSON TYPE OF DISTRIBUTION AND PREPARES
C          THE DIFFERENTIAL EQUATION FOR CUBIC SPLINE SOLUTION --
C          SEE ENTRY PRSNQP BELOW .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*10 TYPEID
      SAVE A1P,B1P,C0P,C1P,C2P
      COMMON / PRSNCM / PEX,PSD
      DATA FACTOR,RANGED,TOLER/9.9999999D-1,10D0,1D-4/
      PEX=EX
      PSD=DSQRT(V)
      SKEW=T/PSD**3
      BETA1=SKEW**2
      BETA2=F/V**2
      CALL PTYPE(BETA1,BETA2,AP,XK,ITYPE,TYPEID,TOLER)
      C0=(4*BETA2-3*BETA1)/AP
      C1=SKEW*(BETA2+3)/AP
      C2=(2*BETA2-3*BETA1-6)/AP
      IF(ITYPE.LE.0) GO TO 120
      XL=-RANGED
      XU=RANGED
      IF(DMAX1(DABS(C0),DABS(C1)).LE.1D16*DABS(C2)) GO TO 40
C
C          C2 IS ESSENTIALLY ZERO .
C          ARE THERE ANY ROOTS OF STRAIGHT LINE
C          IN THE INTERVAL (-RANGED,RANGED) ?
C
      IF(DABS(C0).GT.RANGED*DABS(C1)) GO TO 100
      ALPHA1=-C0/C1*FACTOR
      IF(ALPHA1.GT.0) XU=ALPHA1
      IF(ALPHA1.LT.0) XL=ALPHA1
      GO TO 100
C
C          C2 NOT ZERO # SOLVE QUADRATIC
C
40    DISCR=C1**2-4*C0*C2
      IF(DISCR.LE.-1D-20) GO TO 100
      DISCR=DSQRT(DMAX1(DISCR,0D0))
      ALPHA1=FACTOR*(-C1+DISCR)/(2*C2)
      ALPHA2=FACTOR*(-C1-DISCR)/(2*C2)
      IF(ALPHA1.LT.0) XL=DMAX1(XL,ALPHA1)
      IF(ALPHA2.LT.0) XL=DMAX1(XL,ALPHA2)
      IF(ALPHA1.GT.0) XU=DMIN1(XU,ALPHA1)
      IF(ALPHA2.GT.0) XU=DMIN1(XU,ALPHA2)
100   A1P=C1
      B1P=1
      C0P=C0
      C1P=C1
      C2P=C2
C          IF C1+X IS A FACTOR OF C0+C1*X+C2*X**2 ,
C          DIVIDE IT OUT .
      IF(DABS(C0-C1**2+C2*C1**2).GE.1D-20) GO TO 120
      A1P=1
      B1P=0
      C2P=0
      C0P=C1*(1-C2)
      C1P=C2
120   RETURN
C
      ENTRY PRSNQP ( X,Q,P )
C
      Q=A1P+B1P*X
C
      P=(C2P*X+C1P)*X+C0P
C
      RETURN
      END
      FUNCTION INTVL2 ( X,I,XT,NT )
C
C          INTVL2 = J , WHERE X IS BETWEEN XT(J) AND XT(J+1)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XT(NT)
      INTVL2=0
      IF(X.LT.XT(1)) GO TO 100
      INTVL2=NT
      IF(X.GT.XT(NT)) GO TO 100
      IH=NT-1
      IL=1
      IF(I.GE.IL .AND. I.LE.IH) GO TO 20
10    I=(IL+IH)/2
20    IF(X.LT.XT(I)) GO TO 40
      IF(X.GT.XT(I+1)) GO TO 50
      INTVL2=I
      GO TO 100
40    IH=I-1
      INTVL2=-40
      IF(IH.LT.IL) GO TO 100
      GO TO 10
50    IL=I+1
      INTVL2=-50
      IF(IL.GT.IH) GO TO 100
      GO TO 10
100   RETURN
      END
      SUBROUTINE TRNCL4 ( MU,SIGMA,D,IFLAG,A,B,EX,V,T,F,PR )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      IF(IFLAG) 10,20,30
10    CALL TRNCLN(MU,SIGMA,-D,-B,-A,EX,V,T,F,PR)
      EX=-EX
      T=-T
      GO TO 40
20    CALL L4CMOM(MU,SIGMA,D,IFLAG,EX,V,T,F)
      PR=1
      GO TO 40
30    CALL TRNCLN(MU,SIGMA,D,A,B,EX,V,T,F,PR)
40    RETURN
      END
      SUBROUTINE TRNCLN ( MU,SIGMA,D,A,B,EX,VAR,E3,E4,PR )
C
C          COMPUTE 4 MOMENTS OF A (POSITIVELY-SKEWED) 3-PARAMETER
C          LOGNORMAL DISTRIBUTION RESTRICTED ( OR TRUNCATED ) TO
C          THE INTERVAL (A,B) .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      DIMENSION CEX(4)
      XA=-10D0
      IF(A.GT.D) XA=(DLOG(A-D)-MU)/SIGMA
      XB=(DLOG(B-D)-MU)/SIGMA
C
      PR=CDFN01(XB)-CDFN01(XA)
C
      DO 10 I=1,4
      P=I
      CEX(I)=DEXP(0.5D0*(P*SIGMA)**2)*
     .       (CDFN01(XB-P*SIGMA)-CDFN01(XA-P*SIGMA))/PR
10    CONTINUE
C
      EX=CEX(1)
C
      VAR=CEX(2)-CEX(1)**2
C
      E3=CEX(3)-3D0*CEX(1)*CEX(2)+2D0*CEX(1)**3
C
      E4=CEX(4)-4D0*CEX(1)*CEX(3)+6D0*CEX(1)**2*CEX(2)-3D0*CEX(1)**4
C
      EXIN=EX
      VARIN=VAR
      E3IN=E3
      E4IN=E4
      CALL PRD4M(DEXP(MU),0D0,0D0,0D0,
     . EXIN,VARIN,E3IN,E4IN,EX,VAR,E3,E4)
      EX=EX+D
      RETURN
      END
      SUBROUTINE L4MODE ( X1,MODE,X2,C1,C2,MU,SIGMA,D,IFLAG )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MODE,MU
      IF(DABS(C2*(X1-MODE)-C1*(X2-MODE)).LE.(X2-X1)*0.0023D0) GO TO 10
C          .0023 IMPLIES SIGMA > .001 IN L3MODE
      CALL L3MODE(X1,MODE,X2,C1,C2,MU,SIGMA,D,IERR)
      IFLAG=1
      IF(IERR.LT.2) RETURN
      IFLAG=-1
      CALL L3MODE(-X2,-MODE,-X1,-C2,-C1,MU,SIGMA,D,IERR)
      D=-D
      IF(IERR.GE.2) IFLAG=2
      RETURN
10    IFLAG=0
      MU=MODE
      SIGMA=0.5D0*((X1-MODE)/C1+(X2-MODE)/C2)
      D=0D0
      RETURN
      END
      SUBROUTINE LN4MOM ( EX,VAR,E3,MU,SIGMA,D,IFLAG )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      IF(VAR.LT.1D-7*EX**2) GO TO 20
      SKEW=E3/VAR**1.5
      IF(DABS(SKEW).LT.1D-4) SKEW=0D0
      IF(SKEW) 10,20,30
10    IFLAG=-1
      CALL LN3MOM(-EX,VAR,-E3,MU,SIGMA,D)
      D=-D
      RETURN
20    IFLAG=0
      MU=EX
      SIGMA=DSQRT(VAR)
      D=0D0
      RETURN
30    IFLAG=1
      CALL LN3MOM(EX,VAR,E3,MU,SIGMA,D)
      RETURN
      END
      SUBROUTINE L4CMOM ( MU,SIGMA,D,IFLAG,EX,VAR,E3,E4 )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      IF(IFLAG.NE.0) GO TO 10
      EX=MU
      VAR=SIGMA**2
      E3=0D0
      E4=3D0*VAR**2
      RETURN
10    ALPHA=DEXP(MU+0.5D0*SIGMA**2)
      ETASQ=DEXP(SIGMA**2)-1D0
      EX=D+IFLAG*ALPHA
      VAR=ALPHA**2*ETASQ
      E3=IFLAG*ALPHA**3*(ETAS1**3+3D0*ETASQ**2)
      E4=VAR**2*(ETASQ**4+6D0*ETASQ**3+15D0*ETASQ**2+16D0*ETASQ+3D0)
      RETURN
      END
      FUNCTION CDFLN4 ( MU,SIGMA,D,IFLAG,X )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      IF(IFLAG) 10,20,30
10    CDFLN4=1D0-CDFLN3(MU,SIGMA,-D,-X)
      RETURN
20    CDFLN4=CDFN01((X-MU)/SIGMA)
      RETURN
30    CDFLN4=CDFLN3(MU,SIGMA,D,X)
      RETURN
      END
      FUNCTION QNTLN4 ( MU,SIGMA,D,IFLAG,P )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      Q=P
      IF(IFLAG.LT.0) Q=1D0-P
      QNTLN4=MU+SIGMA*QNTN01(Q)
      IF(IFLAG.EQ.0) RETURN
      QNTLN4=D+IFLAG*DEXP(QNTLN4)
      RETURN
      END
      SUBROUTINE L3MODE ( X1,MODE,X2,C1,C2,MU,SIGMA,D,IERR )
C
C          COMPUTES MU, SIGMA, AND D FOR A LOGNORMAL
C          GIVEN X1, MODE, AND X2 .
C
C          ON RETURN, IERR = 0 --> ALL OK #
C                            1 --> SIGMA ITERATION FAILED TO CONVERGE
C                            2 --> IMPROPER INPUT DATA--PARAMETERS
C                                  MU, SIGMA AND D SET TO 0.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MODE,MU
      EPS=1D-7
      C1OLD=0D0
      C20LD=0D0
      MU=0
      SIGMA=0
      D=0
      IERR=2
      IF(C1.GE.0D0 .OR. C2.LE.0D0) RETURN
      IF(X2.LE.MODE) RETURN
      IF(X1.GE.X2) RETURN
C
      IF(DABS(C1-C1OLD)+DABS(C2-C2OLD).LT.EPS) GO TO 50
      C1OLD=C1
      C2OLD=C2
C
C          GET BOUNDS ON RATIO, R = (MODE-X1)/(X2-X1)
C
      SMAX=DABS(C1)
      RMAX=SMAX/(SMAX+C2)
      DS=1D0
      K=0
10    IF(K.GE.200) GO TO 30
      K=K+1
      S=SMAX+DS
      E1=DEXP(C1*S)
      E2=DEXP(C2*S)
      ES2=DEXP(-S**2)
      FN=ES2-E1
      FD=E2-E1
      FNP=-2D0*S*ES2-C1*E1
      FDP=C2*E2+C1*E1
      FPN=FNP*FD-FN*FDP
      IF(FPN.LE.0D0) GO TO 20
      DS=0.5D0*DS
      GO TO 10
20    SMAX=S
      IF(DABS(FPN).GT.1D-4*DABS(FN*FD)) GO TO 10
30    SMAX=0.999*S
      E1=DEXP(C1*SMAX)
      E2=DEXP(C2*SMAX)
      ES2=DEXP(-SMAX**2)
      RMIN=(ES2-E1)/(E2-E1)
C
50    R=(MODE-X1)/(X2-X1)
      IF(R.GE.RMAX) RETURN
      IF(R.LT.RMIN) RETURN
C
C          GET INITIAL GUESS FOR SIGMA AND START ITERATION
C
      S=0.5*SMAX
      IERR=1
      K=0
100   K=K+1
      E1=DEXP(C1*S)
      E2=DEXP(C2*S)
      ES2=DEXP(-S**2)
      FN=ES2-E1
      FD=E2-E1
      F=FN/FD-R
      IF(DABS(F).LT.EPS) GO TO 200
      IF(K.GE.100) GO TO 300
      FNP=-2D0*S*ES2-C1*E1
      FDP=C2*E2-C1*E1
      FP=(FNP*FD-FN*FDP)/FD**2
      S=S-F/FP
      S=DMAX1(0.001D0,DMIN1(S,SMAX))
      GO TO 100
200   IERR=0
300   SIGMA=S
      MU=DLOG((X2-MODE)/(E2-ES2))
      D=X1-DEXP(MU+C1*S)
      RETURN
      END
      SUBROUTINE LN3MOM ( EX,VAR,E3,MU,SIGMA,D )
C
C          COMPUTE THE 3 PARAMETERS OF THE (POSITIVELY SKEWED)
C          LOGNORMAL DISTRIBUTION HAVING THE SPECIFIED MOMENTS,
C          EX,VAR,AND E3 .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      SKEW=E3/VAR**1.5
      ETA=0.3D0
      N=0
  100 F=ETA**3 + 3D0*ETA - SKEW
      IF (DABS(F).LT.1.D-8) GO TO 200
      N=N+1
      IF(N.GT.25) GO TO 200
      FP=3D0*(ETA**2+1D0)
      ETA=ETA - F/FP
      GO TO 100
200   ETASQ=ETA**2
      ALPHA=DSQRT(VAR/ETASQ)
C
      SIGMA=DSQRT(DLOG(ETASQ+1D0))
C
      MU=DLOG(ALPHA)-0.5D0*SIGMA**2
C
      D=EX-ALPHA
C
      RETURN
      END
      FUNCTION CDFLN3 ( MU,SIGMA,D,X )
C
C          CDFLN3 IS THE PROBABILITY THAT A (POSITIVELY SKEWED)
C          LOGNORMAL VARIABLE WITH PARAMETERS MU, SIGMA, AND D
C          WILL NOT EXCEED X , I.E.
C          CDFLN3 IS THE DISTRIBUTION FUNCTION EVALUATED AT X .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MU
      CDFLN3=0D0
      IF(X.LE.D) RETURN
      CDFLN3=CDFN01((DLOG(X-D)-MU)/SIGMA)
      RETURN
      END
      FUNCTION CDFN01 ( X )
C
C          CDFNO1(X) = PROB( N(0,1) < X ) , WITH
C          ERROR < 7.5D-8
C
C          SEE ABRAMOWITZ AND STEGUN,
C          "HANDBOOK OF MATHEMATICAL FUNCTIONS," 1968, PAGE 932.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(5)
      DATA P/.2316419D0/,R2PI/0.3989422804D0/,
     .     B/.319381530D0,-.356563782D0,1.781477937D0,
     .      -1.821255978D0,1.330274429D0/
      T=1D0/(1D0+DABS(X)*P)
      PX=B(5)
      DO 10 I=1,4
      PX=T*PX+B(5-I)
10    CONTINUE
      PX=T*PX
      ZX=DEXP(-0.5D0*X**2)*R2PI
      CDFN01=1D0-ZX*PX
      IF(X.LT.0D0) CDFN01=1D0-CDFN01
      RETURN
      END
      FUNCTION QNTN01 ( P )
C
C          QNTN01(P) = X , WHERE
C          PROB( N(0,1) < X ) = P , WITH
C          ERROR < 4.5D-4
C
C          SEE ABRAMOWITZ AND STEGUN,
C          "HANDBOOK OF MATHEMATICAL FUNCTIONS," 1968, PAGE 933.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(3),D(3)
      DATA C/2.515517D0,.802853D0,.010328D0/,
     .     D/1.432788D0,.189269D0,.001308D0/
      Q=1D0-P
      IF(P.LT.0.5D0) Q=P
      T=DSQRT(DLOG(1D0/Q**2))
      XQ=T-(C(1)+C(2)*T+C(3)*T**2)/(1D0+D(1)*T+D(2)*T**2+D(3)*T**3)
      QNTN01=XQ
      IF(P.LT.0.5D0) QNTN01= -QNTN01
      RETURN
      END
      SUBROUTINE SUM4MI ( E1,V1,T1,F1,E2,V2,T2,F2,
     .                    ES,VS,TS,FS )
C
C          COMPUTES THE FIRST 4 MOMENTS OF S = X1 + X2 ,
C          WHERE X1 AND X2 ARE INDEPENDENT RANDOM VARIABLES.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      FS=F1+F2+6*V1*V2
      ES=E1+E2
      VS=V1+V2
      TS=T1+T2
      RETURN
      END
C      SUBROUTINE PCSUM ( EX1,VAR1,E31,E41,EX2,VAR2,E32,E42,
C     .                   EXS,VARS,E3S,E4S )
C
C          CALCULATE FIRST 4 MOMENTS OF S = X1 + X2 USING THE
C          FIRST 4 MOMENTS OF X1 AND X2, WHERE X1 AND X2 ARE
C          PERFECTLY CORRELATED, I.E. X2 = A*X1 + B , A # -1 .
C
       IMPLICIT REAL*8 (A-H,O-Z)
       DATA ONE3RD/0.3333333333333333D0/
C
       EXS=EX1+EX2
C
       VARS=VAR1+VAR2+2D0*DSQRT(VAR1*VAR2)
C
       CUBRT1=DABS(E31)**ONE3RD
       IF(E31.LT.0D0) CUBRT1=-CUBRT1
       CUBRT2=DABS(E32)**ONE3RD
       IF(E32.LT.0D0) CUBRT2=-CUBRT2
C
       E3S=(CUBRT1+CUBRT2)**3
C
C
       E4S=(E41**0.25D0 + E42**0.25D0)**4
C
       RETURN
       END
      SUBROUTINE PRD4M ( EX1,VAR1,E31,E41,EX2,VAR2,E32,E42,
     .                   EP,VARP,E3P,E4P )
C
C          PRDMOM COMPUTES THE 1ST 4 MOMENTS OF
C          P = X1 * X2 , WHERE
C          X1 AND X2 ARE INDEPENDENT #
C          THE 1ST 4 MOMENTS OF XI ARE EXI, VARI, E3I, AND E4I.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      EP=EX1*EX2
C
      VARP=VAR1*VAR2+EX1**2*VAR2+EX2**2*VAR1
C
      E3P=E31*E32+E31*EX2*(3D0*VAR2+EX2**2)
     .   +E32*EX1*(3D0*VAR1+EX1**2)
     .   +6D0*EX1*EX2*VAR1*VAR2
C
      E4P=(E41+4D0*EX1*E31+6D0*EX1**2*VAR1+EX1**4)*
     .    (E42+4D0*EX2*E32+6D0*EX2**2*VAR2+EX2**4)
     .    -4D0*EP*E3P-6D0*EP**2*VARP-EP**4
C
      RETURN
      END
      SUBROUTINE UNCMOM ( EXC,VARC,E3C,E4C,PO,EX,VAR,E3,E4 )
C
C          GIVEN THE CONDITIONAL MOMENTS AND THE PROBABILITY
C          OF OCCURRENCE, PO, THE UNCONDITIONAL MOMENTS ARE
C          COMPUTED.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      EX=PO*EXC
C
      VAR=PO*(VARC+(1D0-PO)*EXC**2)
C
      E3=PO*((1D0-PO)*((1D0-2D0*PO)*EXC**3+3D0*EXC*VARC)+E3C)
C
      E4=PO*(E4C+4D0*(1D0-PO)*EXC*E3C+6D0*(1D0-PO)**2*EXC**2*VARC
     .     +(1D0-PO)*(1D0-3D0*PO+3D0*PO**2)*EXC**4)
C
      RETURN
      END
      SUBROUTINE PTYPE ( B1,B2,APRIME,K,ITYPE,TYPMSG,TOLER )
C
C          PTYPE DETERMINES WHICH (IF ANY) OF THE PEARSON
C          DISTRIBUTIONS SATISFIES BETA-1 = B1 AND BETA-2 = B2 .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 K
      CHARACTER*10 TMESG(13),TYPMSG
      DIMENSION MTYPE(13)
      DATA TMESG/'TYPE I','IMPOSSIBLE','EXPONENTL','NORMAL','TYPE II',
     .'TYPE VII','TYPE III','TYPE V','TYPE I','UNIFORM','TYPE VI',
     .'TYPE IV','NOT PEARSN'/
      DATA MTYPE/1,-1,3,8,2,7,3,5,1,1,6,4,0/
      APRIME=10*B2-12*B1-18
      K=0
      M=10
      IF(B1.LT.TOLER .AND. DABS(B2-1.8D0).LT.TOLER) GO TO 100
      M=1
      IF(DABS(APRIME).LT.TOLER) GO TO 100
      M=2
      IF(B2.LT.1D0) GO TO 100
      IF(B2-B1.LT.1D0) GO TO 100
      M=3
      IF(DABS(DSQRT(B1)-2).LT.TOLER .AND.
     .   DABS(B2-9).LT.TOLER) GO TO 100
      M=4
      IF(DABS(B2-3D0).LT.TOLER .AND. B1.LT.TOLER) GO TO 100
      M=5
      IF(1.0.LT.B2 .AND. B2+TOLER.LT.3 .AND.
     .   B1.LT.TOLER) GO TO 100
      M=6
      IF(B2.GT.3+TOLER .AND. B1.LT.TOLER) GO TO 100
      M=7
      IF(DABS(2*B2-3*B1-6).LT.TOLER) GO TO 100
      M=8
      K=B1*(B2+3)**2/(4*(2*B2-3*B1-6)*(4*B2-3*B1))
      IF(DABS(K-1).LT.TOLER) GO TO 100
      M=9
      IF(K.LT.0.0) GO TO 100
      M=11
      IF(K.GT.1+TOLER) GO TO 100
      M=12
      IF(0.0.LT.K .AND. K+TOLER.LT.1) GO TO 100
      M=13
100   TYPMSG=TMESG(M)
      ITYPE=MTYPE(M)
      RETURN
      END
      SUBROUTINE GNODES ( XL,XM,XU,X,N,B1 )
C
C          DETERMINES N NODES OF SPLINE WITH LIMITS XL & XU AND
C          MODE, XM . POINTS ARE LOGARITHMICALLY SPACED FROM THE
C          MODE TOWARD THE ENDPOINTS .
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N)
      R=1+.032*DEXP(-1.732868*DSQRT(B1))
      IF(XM.LE.XL) GO TO 20
      IF(XM.GE.XU) GO TO 40
      M=N/2
      N=2*M+1
      X(M+1)=XM
      CALL LGMPTS(X(M+2),M,XM,XU,R)
      CALL LGMPTS(X(1),M,XM,XL,R)
      GO TO 100
20    X(1)=XL
      CALL LGMPTS(X(2),N-1,XL,XU,R)
      GO TO 100
40    CALL LGMPTS(X(1),N-1,XU,XL,R)
      X(N)=XU
100   RETURN
      END
      SUBROUTINE LGMPTS ( X,N,A,B,R )
C
C    FINDS N POINTS LOGARITHMICALLY SPACED FROM A TO B
C    USING RATIO R, RETURNING THEM IN ASCENDING ORDER
C    IN VECTOR X.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N), SUMSAV(200)
      IF (N.LT.2) RETURN
      DIFF = B-A
      ADIFF=DABS(DIFF)
C  FIND FIRST INTERVAL LENGTH, X1
      SUM=1
      NM1=N-1
      RI=R
      DO 50 I=1,NM1
      SUM=SUM+RI
      SUMSAV(I)=SUM
   50 RI=RI*R
      X1=ADIFF/SUM
C  SET INTERVALS
      IF (DIFF.LT.0) GO TO 400
      X(1)=A+X1
      DO 300 I=2,N
  300 X(I)=A+X1*SUMSAV(I-1)
      RETURN
  400 X(N)=A-X1
      DO 500 I=2,N
  500 X(N+1-I)=A-X1*SUMSAV(I-1)
      RETURN
      END
      FUNCTION DTRUNC ( X,N )
C
C          DTRUNC RETURNS THE VALUE OF X TRUNCATED TO
C          N SIGNIFICANT DIGITS.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DTRUNC=0
      IF(X.EQ.0.) RETURN
      ILOG=DLOG10(DABS(X))
      IF(ILOG.LT.0) ILOG=ILOG-1
      XLOG=ILOG-N+1
      XBASE=10D0**XLOG
      IX=DABS(X)/XBASE+0.5D0
      DTRUNC=IX*XBASE
      IF(X.LT.0) DTRUNC= -DTRUNC
      RETURN
      END
      SUBROUTINE L4MEAN ( X1,MEAN,X2,C1,C2,MU,SIGMA,D,IFLAG )
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MEAN,MU
      IF(DABS(C2*(X1-MEAN)-C1*(X2-MEAN)).LE.(X2-X1)*0.0023D0) GO TO 10
C          .0023 IMPLIES SIGMA > .001 IN L3MEAN
      CALL L3MEAN(X1,MEAN,X2,C1,C2,MU,SIGMA,D,IERR)
      IFLAG=1
      IF(IERR.LT.2) RETURN
      IFLAG=-1
      CALL L3MEAN(-X2,-MEAN,-X1,-C2,-C1,MU,SIGMA,D,IERR)
      D=-D
      IF(IERR.GE.2) IFLAG=2
      RETURN
10    IFLAG=0
      MU=MEAN
      SIGMA=0.5D0*((X1-MEAN)/C1+(X2-MEAN)/C2)
      D=0D0
      RETURN
      END
      SUBROUTINE L3MEAN ( X1,MEAN,X2,C1,C2,MU,SIGMA,D,IERR )
C
C          COMPUTES MU, SIGMA, AND D FOR A LOGNORMAL
C          GIVEN X1, MEAN, AND X2 .
C
C          ON RETURN, IERR = 0 --> ALL OK #
C                            1 --> SIGMA ITERATION FAILED TO CONVERGE
C                            2 --> IMPROPER INPUT DATA--PARAMETERS
C                                  MU, SIGMA AND D SET TO 0.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 MEAN,MU
      LOGICAL DIP
      EPS=1D-7
      C10LD=10D0
      C20LD=-10D0
      MU=0
      SIGMA=0
      D=0
      IERR=2
      PRINT 1,X1,MEAN,X2,C1,C2
1     FORMAT(1X/' IN L3MEAN,'/
     .' X1,MEAN,X2,C1,C2 ',1P5E11.3)
      IF(MEAN.LE.X1) RETURN
      IF(X2.LE.X1) RETURN
C
      IF(DABS(C1-C1OLD)+DABS(C2-C2OLD).LT.EPS) GO TO 50
      C1OLD=C1
      C2OLD=C2
C
C          GET BOUNDS ON RATIO, R = (MEAN-X1)/(X2-X1)
C
      DIP=.FALSE.
      R1=DABS(C1)/(DABS(C1)+C2)
      R2=R1
      IF(DABS(C1*C2).LE.1D0) GO TO 50
10    DIP=.TRUE.
      S2=C2*0.001
      DS=2*C2
      K=0
15    IF(K.GE.100) GO TO 30
      K=K+1
      S=S2+DS
      E1=DEXP(C1*S)
      E2=DEXP(C2*S)
      ES2=DEXP(0.5*S**2)
      FN=ES2-E1
      FD=E2-E1
      FNP=S*ES2-C1*E1
      FDP=C2*E2-C1*E1
      FPN=FNP*FD-FN*FDP
      IF(FPN.LE.0D0) GO TO 20
      DS=0.5D0*DS
      GO TO 15
20    S2=S
      IF(DABS(FPN).GT.1D-4*DABS(FN*FD)) GO TO 15
30    E1=DEXP(C1*S2)
      E2=DEXP(C2*S2)
      ES2=DEXP(0.5*S2**2)
      R1=(ES2-E1)/(E2-E1)
C
50    R=(MEAN-X1)/(X2-X1)
      PRINT 51,R,R1,R2,S2
51    FORMAT(1X/' AT 50, R,R1,R2,S2',1P4E11.3)
      IF(R.LT.R1) RETURN
      IF(.NOT. DIP) GO TO 60
C
C          GET INITIAL GUESS FOR SIGMA AND START ITERATION
C
      S=S2/2
      IF(R.LT.R2) GO TO 70
60    S=S2+1
70    IERR=1
      K=0
100   K=K+1
      E1=DEXP(C1*S)
      E2=DEXP(C2*S)
      ES2=DEXP(0.5*S**2)
      FN=ES2-E1
      FD=E2-E1
      F=FN/FD-R
      IF(DABS(F).LT.EPS) GO TO 200
      IF(K.GE.100) GO TO 300
      FNP=S*ES2-C1*E1
      FDP=C2*E2-C1*E1
      FP=(FNP*FD-FN*FDP)/FD**2
      S=S-F/FP
      GO TO 100
200   IERR=0
300   SIGMA=S
      MU=DLOG((X2-MEAN)/(E2-ES2))
      D=X1-DEXP(MU+C1*S)
      RETURN
      END
